/* EPITA - IP - S3/4 */
/* question11 */


# include "question11.h"

size_t prime_sieve(unsigned int n, unsigned int primes[])
{
  unsigned int *nums = calloc(n + 1, sizeof (unsigned int));
  size_t count = 3 < n ? 3 : n;
  for (size_t i = 0; i < count; ++i)
    primes[i] = i + 1;
  for (size_t i = 4; i <= n; ++i)
    nums[i] = (i % 2 == 0) || (i % 3 == 0);
  for (size_t i = 5; i <= n;) {
    for (unsigned int j = i * i; j <= n; j += i)
      nums[j] = 1;
    primes[count] = i;
    count++;
    for (i += 1; i <= n && nums[i]; ++i)
      continue;
  }
  free(nums);
  return count;
}
