/* EPITA - IP - S3/4 */
/* question09 */


# include "question09.h"

static inline
void swap(int *a, int *b)
{
  int c = *a;
  *a = *b;
  *b = c;
}

void array_reverse(int *begin, int *end)
{
  for (--end; begin < end; ++begin, --end) {
    swap(begin, end);
  }
}

int next_permutation(int array[], size_t len)
{
  size_t i = len - 1;
  for (; i > 0 && array[i] < array[i - 1]; --i)
    continue;
  if (i < 1) {
    array_reverse(array, array + len);
    return 0;
  }
  --i;
  size_t j = i + 1;
  for (; j < len - 1 && array[j + 1] > array[i]; ++j)
    continue;
  swap(array + i, array + j);
  array_reverse(array + i + 1, array + len);
  return 1;
}
