/* EPITA - IP - S3/4 */
/* question15 */


# include "question15.h"

struct matrix *matrix_mul(struct matrix *A, struct matrix *B) {
  struct matrix *m = malloc(sizeof (struct matrix));
  m->lines = A->lines;
  m->cols = B->cols;
  m->data = calloc(m->lines * m->cols, sizeof (int));
  for (size_t i = 0; i < m->lines; i++) {
    for (size_t j = 0; j < m->cols; j++) {
      int *cell = m->data + (i * m->cols + j);
      *cell = 0;
      for (size_t k = 0; k < A->cols; k++) {
	*cell += A->data[i * A->cols + k] * B->data[k * B->cols + j];
      }
    }
  }
  return m;
}

