/* EPITA - IP - S3/4 */
/* question17 */

# include "question17.h"

/*
 * mystrncpy(dst,src,len) : copie au plus len caractères de la chaîne src dans
 * la chaîne dst.
 *
 * On suppose que src et dst sont non NULL, src est terminée par un '\0' et
 * dst est de taille suffisante.
 *
 * Dans tous les cas, mystrncpy(dst,src,len) écrit exactement len caractères
 * dans dst.
 *
 * Si le nombre de caractères de src est inférieur à len, alors votre fonction
 * devra remplir la fin de dst par des 0. Sinon (src plus grand que len) votre
 * fonction ne doit pas mettre de '\0' à la fin de dst.
 *
 * (voir strncpy(3))
 */
char *mystrncpy(char * dst, char * src, size_t len) {
  size_t        i;
  for (i=0; i<len && src[i]; ++i)
    dst[i] = src[i];
  for (; i<len; ++i)
    dst[i] = 0;
  return dst;
}
