/* EPITA - IP - S3/4 */
/* question01 */

#define QNUM 1
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question01.h"

static
void fixed_tests(void) {
  printf("Fixed tests:\n");
  for (unsigned long i = 0; i < 6; i++) {
    printf("\tfact(%2lu) = %lu\n", i, fact(i));
  }
}

static
void random_test(size_t len) {
  printf("Random tests:\n");
  for (size_t i = 0; i < len; i++) {
    unsigned long n = random() % 16;
    printf("\tfact(%2lu) = %lu\n", n, fact(n));
  }
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_tests();
      random_test(size);
    }
  exit(0);
}
