/* EPITA - IP - S3/4 */
/* question11 */

#define QNUM 11
#define QOPT "taille"
#define QNOPT 1

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question11.h"

static
void fixed_tests(size_t size) {
  printf("Tests:\n");
  size_t count;
  unsigned int *primes = calloc(size, sizeof (unsigned int));
  count = prime_sieve(size, primes);
  printf("  Found %zu prime numbers smaller or equal to %zu\n", count, size);
  for (unsigned int *p = primes; p < primes + count; ++p) {
    printf("    %u\n", *p);
  }
  free(primes);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      size = strtoul(argv[1], NULL, 10);
      fixed_tests(size);
    }
  exit(0);
}
